from extensions import mongo, db
from Main import app, UPLOAD_FOLDER, ALLOWED_EXTENSIONS
import base64
# from flask import Blueprint

from flask import Response, request, session


# import pymongo
import json
from bson.objectid import ObjectId
from Agripreneur_App.Auth.Token import check_for_token
from werkzeug.security import generate_password_hash, check_password_hash
from werkzeug.utils import secure_filename
# from werkzeug.datastructures import ImmutableMultiDict
import os

# considered about image upload of user


# allowed files
def allowed_file(filename):
    return '.' in filename and \
           filename.rsplit('.', 1)[1].lower() in ALLOWED_EXTENSIONS

# ====Routes====
# ====Upload image====
# @app.route("/users", methods=["POST"])
# def upload_img():

# print(request)

# ====Routes====
# ====post users====
@app.route("/users", methods=["POST"])
def create_user():
    print(request.form)
    try:

        password = request.form.get("password")

        hashed_value = generate_password_hash(password, method='sha256')

        # profile_image = request.form.get("img")

        profile_image = request.form["img"]
        print(profile_image +"===========")

        imgdata = base64.b64decode(profile_image)
        # if profile_image and allowed_file(profile_image.filename):
        filename = secure_filename(profile_image)
        print(filename)
        # imgdata.save(os.path.join(app.config['UPLOAD_FOLDER'], filename))
        with open(filename, 'wb') as f:
            f.write(imgdata)

        # if 'profile_image' in request.files:
        # image_string = base64.b64encode(profile_image.read())
        # db.images.save_file(profile_image.filename, profile_image)

        user = {"name": request.form.get("name"), 
                "email": request.form.get("email"), 
                "password": hashed_value, 
                "district": request.form.get("district"),
                "prof_img_name": filename}
        dbResponse = db.users.insert_one(user)
        print(user)
        print(dbResponse.inserted_id)
        return Response(
            response= json.dumps({"message": "user created", 
            "id": f"{dbResponse.inserted_id}"}),
            status=200,

        )

        

    except Exception as Ex:   
        print("**********") 
        print(Ex)
        return Response(
            response= json.dumps({"message": "cannot read user"}),
            status=500,

        )


# ====Routes====
# ====Get users====
@app.route("/getUsers", methods=["GET"])
def get_some_users():
    try:
        data = list(db.users.find())
        for user in data:
            user["_id"] = str(user["_id"])

        return Response(
            response= json.dumps(data),
            status=200,

        )

    except Exception as Ex:   
        print("**********") 
        print(Ex)


# ====Routes====
# ====update user====

@app.route("/updateUsers/<id>", methods=["PUT"])
@check_for_token
def update_user(id):
    request.headers
    print("heeee")
    id = session['Auth']['_id']

    try:
        
        dbResponse = db.users.update_one(
            {"_id": ObjectId(id)},
            {"$set": {"name": request.form["name"]}},upsert=True)
        dbResponse = db.users.update_one(
            {"_id": ObjectId(id)},
            {"$set": {"district": request.form["district"]}},upsert=True)

        # for attr in dir(dbResponse):
        #     print(f"{attr}")

        print(dbResponse.upserted_id)
        return Response(
            response= json.dumps({"message": "updated user"}),
            status=200,

        )
    except Exception as Ex:   
        print("**********") 
        print(Ex)
        return Response(
            response= json.dumps({"message": "cannot update user"}),
            status=500,

        )



# ====Routes====
# ====delete user====

@app.route("/deleteUsers/<id>", methods=["DELETE"])
@check_for_token
def delete_user(id):
    request.headers
    id = session['Auth']['_id']
    try:
        dbResponse = db.users.delete_one({"_id": ObjectId(id)},)

        return Response(
            response= json.dumps({"message": "user deleted", "id": f"{id}"}),
            status=200,

        )  

    except Exception as Ex:   
        print("**********") 
        print(Ex)
        return Response(
            response= json.dumps({"message": "cannot delete user"}),
            status=500,

        )    
